//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3C1786B8032C.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3C1786B8032C.cm

//## begin module%3C1786B8032C.cp preserve=no
//## end module%3C1786B8032C.cp

//## Module: Lstat%3C1786B8032C; Package specification
//## Subsystem: XSFit::StatMethod::Lstat%3C17866A03CC
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/StatMethod/Lstat/Lstat.h

#ifndef LSTAT_H
#define LSTAT_H 1

//## begin module%3C1786B8032C.additionalIncludes preserve=no
//## end module%3C1786B8032C.additionalIncludes

//## begin module%3C1786B8032C.includes preserve=yes
#include <xsTypes.h>
//## end module%3C1786B8032C.includes

// string
#include <string>
// StatMethod
#include <XSFit/Fit/StatMethod.h>
//## begin module%3C1786B8032C.declarations preserve=no
//## end module%3C1786B8032C.declarations

//## begin module%3C1786B8032C.additionalDeclarations preserve=yes
#include <cmath>
//## end module%3C1786B8032C.additionalDeclarations


//## begin Lstat%3B7BFB8002F2.preface preserve=yes
//## end Lstat%3B7BFB8002F2.preface

//## Class: Lstat%3B7BFB8002F2
//## Category: XSFit::StatMethod%3FC51D1601E4
//## Subsystem: XSFit::StatMethod::Lstat%3C17866A03CC
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class Lstat : public StatMethod  //## Inherits: <unnamed>%3B7BFB990382
{
  //## begin Lstat%3B7BFB8002F2.initialDeclarations preserve=yes
  //## end Lstat%3B7BFB8002F2.initialDeclarations

  private:
    //## Class: Dterm0%421E0D0D0367; private
    //## Category: XSFit::StatMethod%3FC51D1601E4
    //## Subsystem: XSFit::StatMethod::Lstat%3C17866A03CC
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct Dterm0 
    {

        //## Other Operations (specified)
          //## Operation: calc%421E0EA00244
          static Real calc (int j, Real dlogS);

        // Data Members for Class Attributes

          //## Attribute: flag%421E0E5C018D
          //## begin Lstat::Dterm0::flag%421E0E5C018D.attr preserve=no  public: static const int {U} 0
          static const int flag;
          //## end Lstat::Dterm0::flag%421E0E5C018D.attr

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Class: Dterm1%421E104B021A; private
    //## Category: XSFit::StatMethod%3FC51D1601E4
    //## Subsystem: XSFit::StatMethod::Lstat%3C17866A03CC
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct Dterm1 
    {

        //## Other Operations (specified)
          //## Operation: calc%421E1086022C
          static Real calc (int j, Real dlogS);

        // Data Members for Class Attributes

          //## Attribute: flag%421E109100BB
          //## begin Lstat::Dterm1::flag%421E109100BB.attr preserve=no  public: static const int {U} 1
          static const int flag;
          //## end Lstat::Dterm1::flag%421E109100BB.attr

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Class: Dterm2%421E10AC0232; private
    //## Category: XSFit::StatMethod%3FC51D1601E4
    //## Subsystem: XSFit::StatMethod::Lstat%3C17866A03CC
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct Dterm2 
    {

        //## Other Operations (specified)
          //## Operation: calc%421E10D00034
          static Real calc (int j, Real dlogS);

        // Data Members for Class Attributes

          //## Attribute: flag%421E10D70273
          //## begin Lstat::Dterm2::flag%421E10D70273.attr preserve=no  public: static const int {U} 2
          static const int flag;
          //## end Lstat::Dterm2::flag%421E10D70273.attr

      public:
      protected:
      private:
      private: //## implementation
    };

  public:
    //## Constructors (generated)
      Lstat();

      Lstat(const Lstat &right);


    //## Other Operations (specified)
      //## Operation: clone%3C84ED4901AB
      virtual Lstat* clone () const;

      //## Operation: plotChi%42166E360373
      virtual Real plotChi (Real obs, Real mod, Real error, Real areaTime, const Real& NODATA) const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSFit::Fit::<unnamed>%3DD3F19800EE
      //## Role: Lstat::fullName%3DD3F1990375
      virtual const std::string& fullName () const;

      //## Association: XSFit::Fit::<unnamed>%3DD4086B0139
      //## Role: Lstat::scriptName%3DD4086C0171
      virtual const std::string& scriptName () const;

    // Additional Public Declarations
      //## begin Lstat%3B7BFB8002F2.public preserve=yes
      //## end Lstat%3B7BFB8002F2.public

  protected:
    // Additional Protected Declarations
      //## begin Lstat%3B7BFB8002F2.protected preserve=yes
      //## end Lstat%3B7BFB8002F2.protected

  private:

    //## Other Operations (specified)
      //## Operation: doReport%3C90CF490277
      virtual void doReport (Fit* fit) const;

      //## Operation: sumDerivs%416D5BD903B2
      virtual Real sumDerivs (int parameterIndex, bool isRespar = false);

      //## Operation: sumSecondDerivs%416D5BE40260
      virtual Real sumSecondDerivs (int pi, int pj, bool isPiResp = false, bool isPjResp = false);

      //## Operation: getDifferences%42166C4B0360
      virtual ArrayContainer getDifferences (const Fit* fit) const;

      //## Operation: lorTerm%421CEF4003C8
      static Real lorTerm (const int n1, const int n2, const int n3);

      //## Operation: adjustForFrozen%448457E202B3
      std::pair<Real,Real> adjustForFrozen (const SpectralData* spec, const std::vector<Model*>& models, const std::map<Model*,ArrayContainer >& savedValsForFrozen);

      //## Operation: checkForPoisson%44982E7202BE
      static bool checkForPoisson ();

    // Additional Private Declarations
      //## begin Lstat%3B7BFB8002F2.private preserve=yes
      //## end Lstat%3B7BFB8002F2.private

  private: //## implementation

    //## Other Operations (specified)
      //## Operation: doPerform%3B7BFEF4024A
      virtual void doPerform (Fit* fit);

      //## Operation: doInitialize%3C5AAD490111
      virtual void doInitialize (Fit* fit);

      //## Operation: doDeallocate%3C5AAD7A02A4
      virtual void doDeallocate ();

      //## Operation: doReset%3C6BE5F6025C
      virtual void doReset (Fit* fit);

    // Data Members for Class Attributes

      //## Attribute: firstDerivCoefficient%42166FB2001B
      //## begin Lstat::firstDerivCoefficient%42166FB2001B.attr preserve=no  private: ArrayContainer {U} 
      ArrayContainer m_firstDerivCoefficient;
      //## end Lstat::firstDerivCoefficient%42166FB2001B.attr

      //## Attribute: secondDerivCoefficient%42166FC100CA
      //## begin Lstat::secondDerivCoefficient%42166FC100CA.attr preserve=no  private: ArrayContainer {U} 
      ArrayContainer m_secondDerivCoefficient;
      //## end Lstat::secondDerivCoefficient%42166FC100CA.attr

      //## Attribute: sourceCounts%421CEDF40362
      //## begin Lstat::sourceCounts%421CEDF40362.attr preserve=no  private: int {U} 
      int m_sourceCounts;
      //## end Lstat::sourceCounts%421CEDF40362.attr

      //## Attribute: backgroundCounts%421CEE0D018A
      //## begin Lstat::backgroundCounts%421CEE0D018A.attr preserve=no  private: int {U} 
      int m_backgroundCounts;
      //## end Lstat::backgroundCounts%421CEE0D018A.attr

      //## Attribute: FLOOR%421F47CC0184
      //## begin Lstat::FLOOR%421F47CC0184.attr preserve=no  private: static const Real {U} 1.0e-5
      static const Real s_FLOOR;
      //## end Lstat::FLOOR%421F47CC0184.attr

    // Data Members for Associations

      //## Association: XSFit::Fit::<unnamed>%3DD3F19800EE
      //## begin Lstat::fullName%3DD3F1990375.role preserve=no  public: std::string { -> 1VHgN}
      std::string m_fullName;
      //## end Lstat::fullName%3DD3F1990375.role

      //## Association: XSFit::Fit::<unnamed>%3DD4086B0139
      //## begin Lstat::scriptName%3DD4086C0171.role preserve=no  public: std::string { -> 1VHgN}
      std::string m_scriptName;
      //## end Lstat::scriptName%3DD4086C0171.role

    // Additional Implementation Declarations
      //## begin Lstat%3B7BFB8002F2.implementation preserve=yes
      template <typename T>
      Real lorSum(const Real S) const;
      //## end Lstat%3B7BFB8002F2.implementation
};

//## begin Lstat%3B7BFB8002F2.postscript preserve=yes
//## end Lstat%3B7BFB8002F2.postscript

// Class Lstat::Dterm0 


//## Other Operations (inline)
inline Real Lstat::Dterm0::calc (int j, Real dlogS)
{
  //## begin Lstat::Dterm0::calc%421E0EA00244.body preserve=yes
   return j*dlogS;
  //## end Lstat::Dterm0::calc%421E0EA00244.body
}

// Class Lstat::Dterm1 


//## Other Operations (inline)
inline Real Lstat::Dterm1::calc (int j, Real dlogS)
{
  //## begin Lstat::Dterm1::calc%421E1086022C.body preserve=yes
   Real rj = static_cast<Real>(j);
   return std::log(rj) + (rj-1)*dlogS;
  //## end Lstat::Dterm1::calc%421E1086022C.body
}

// Class Lstat::Dterm2 


//## Other Operations (inline)
inline Real Lstat::Dterm2::calc (int j, Real dlogS)
{
  //## begin Lstat::Dterm2::calc%421E10D00034.body preserve=yes
   Real rj = static_cast<Real>(j);
   return std::log(rj) + std::log(rj-1) + (rj-2)*dlogS;
  //## end Lstat::Dterm2::calc%421E10D00034.body
}

// Class Lstat 

//## Get and Set Operations for Associations (inline)

inline const std::string& Lstat::fullName () const
{
  //## begin Lstat::fullName%3DD3F1990375.get preserve=no
  return m_fullName;
  //## end Lstat::fullName%3DD3F1990375.get
}

inline const std::string& Lstat::scriptName () const
{
  //## begin Lstat::scriptName%3DD4086C0171.get preserve=no
  return m_scriptName;
  //## end Lstat::scriptName%3DD4086C0171.get
}

//## begin module%3C1786B8032C.epilog preserve=yes
//## end module%3C1786B8032C.epilog


#endif
